#ifndef _AUDIOSOURCEMKV_H_
#define _AUDIOSOURCEMKV_H_


class AudioSourceMKV : public vdxunknown<IVDXStreamSource>, public IVDXStreamSourceV3, public IVDXAudioSource {

private:
	InputFileMKV*   const parentPtr;
	MatroskaTrack*  const audio;

	IVDXStreamSource::ErrorMode errmode;

	unsigned char*  pStreamBuf;
	DWORD           dwStreamBlock;
	__int64         iStreamPos;

	void        PCMByteSwap(void *lpBuffer, int len);
	int         ReadStream(void *lpBuffer, __int64 pos, int len);
	bool        ReadPCM(sint64 lStart, uint32 lCount, void *lpBuffer, uint32 cbBuffer, uint32 *lBytesRead, uint32 *lSamplesRead);

public:
	AudioSourceMKV(InputFileMKV *const pp, MatroskaTrack *const mt);
	~AudioSourceMKV();

	// IVDXUnknown
	int         VDXAPIENTRY AddRef();
	int         VDXAPIENTRY Release();
	void*       VDXAPIENTRY AsInterface(uint32 iid);

	// IVDXStreamSource
	void        VDXAPIENTRY GetStreamSourceInfo(VDXStreamSourceInfo&);
	bool        VDXAPIENTRY Read(sint64 lStart, uint32 lCount, void *lpBuffer, uint32 cbBuffer, uint32 *lBytesRead, uint32 *lSamplesRead);
	const void* VDXAPIENTRY GetDirectFormat();
	int         VDXAPIENTRY GetDirectFormatLen();
	ErrorMode   VDXAPIENTRY GetDecodeErrorMode();
	void        VDXAPIENTRY SetDecodeErrorMode(ErrorMode mode);
	bool        VDXAPIENTRY IsDecodeErrorModeSupported(ErrorMode mode);
	bool        VDXAPIENTRY IsVBR();
	sint64      VDXAPIENTRY TimeToPositionVBR(sint64 us);
	sint64      VDXAPIENTRY PositionToTimeVBR(sint64 samples);

	// IVDXStreamSourceV3
	void        VDXAPIENTRY GetStreamSourceInfoV3(VDXStreamSourceInfoV3&);

	// IVDXAudioSource
	void        VDXAPIENTRY GetAudioSourceInfo(VDXAudioSourceInfo& info);
};


#endif	// _AUDIOSOURCEMKV_H_

