#ifndef _VIDEOSOURCEMKV_H_
#define _VIDEOSOURCEMKV_H_


class VideoSourceMKV : public vdxunknown<IVDXStreamSource>, public IVDXVideoSource {

private:
	InputFileMKV*   const parentPtr;
	MatroskaTrack*  const video;
	MatroskaTrack*  const audio;

	IVDXStreamSource::ErrorMode errmode;

	DWORD           dwPrevSample;
	unsigned char*  frame_buffer;

	int   UnwrapAVCFrame(unsigned char *dst, const unsigned char *src, int len);

public:
	VideoSourceMKV(InputFileMKV* const pp, MatroskaTrack *const vt, MatroskaTrack *const at);
	~VideoSourceMKV();

	// IVDXUnknown
	int         VDXAPIENTRY AddRef();
	int         VDXAPIENTRY Release();
	void*       VDXAPIENTRY AsInterface(uint32 iid);

	// IVDXStreamSource
	void        VDXAPIENTRY GetStreamSourceInfo(VDXStreamSourceInfo&);
	bool        VDXAPIENTRY Read(sint64 lStart, uint32 lCount, void *lpBuffer, uint32 cbBuffer, uint32 *lBytesRead, uint32 *lSamplesRead);
	const void* VDXAPIENTRY GetDirectFormat();
	int         VDXAPIENTRY GetDirectFormatLen();
	ErrorMode   VDXAPIENTRY GetDecodeErrorMode();
	void        VDXAPIENTRY SetDecodeErrorMode(ErrorMode mode);
	bool        VDXAPIENTRY IsDecodeErrorModeSupported(ErrorMode mode);
	bool        VDXAPIENTRY IsVBR();
	sint64      VDXAPIENTRY TimeToPositionVBR(sint64 us);
	sint64      VDXAPIENTRY PositionToTimeVBR(sint64 samples);

	// IVDXVideoSource
	void        VDXAPIENTRY GetVideoSourceInfo(VDXVideoSourceInfo& info);
	bool        VDXAPIENTRY CreateVideoDecoderModel(IVDXVideoDecoderModel **);
	bool        VDXAPIENTRY CreateVideoDecoder(IVDXVideoDecoder **);
	void        VDXAPIENTRY GetSampleInfo(sint64 sample_num, VDXVideoFrameInfo& frameInfo);
	bool        VDXAPIENTRY IsKey(sint64 sample_num);
	sint64      VDXAPIENTRY GetFrameNumberForSample(sint64 sample_num);
	sint64      VDXAPIENTRY GetSampleNumberForFrame(sint64 frame_num);
	sint64      VDXAPIENTRY GetRealFrame(sint64 frame_num);
	sint64      VDXAPIENTRY GetSampleBytePosition(sint64 sample_num);
};


#endif	// _VIDEOSOURCEMKV_H_

